package com.cico.nest.lcdp.boot.core.qxsd.application.service;

import java.util.*;

import com.cico.nest.lcdp.boot.core.qxsd.adapter.web.vo.tunnelFacility.TunnelFacilityPageReqVO;
import com.cico.nest.lcdp.boot.core.qxsd.adapter.web.vo.tunnelFacility.TunnelFacilitySaveReqVO;
import com.cico.nest.lcdp.boot.core.qxsd.infrastructure.gatewayimpl.database.dataobject.TunnelFacilityDO;
import jakarta.validation.*;
import com.cico.nest.lcdp.framework.common.pojo.PageResult;

/**
 * 隧道设施 Service 接口
 *
 * @author 管理员
 */
public interface TunnelFacilityService {

    /**
     * 创建隧道设施
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createTunnelFacility(@Valid TunnelFacilitySaveReqVO createReqVO);

    /**
     * 更新隧道设施
     *
     * @param updateReqVO 更新信息
     */
    void updateTunnelFacility(@Valid TunnelFacilitySaveReqVO updateReqVO);

    /**
     * 删除隧道设施
     *
     * @param id 编号
     */
    void deleteTunnelFacility(String id);

    /**
     * 获得隧道设施
     *
     * @param id 编号
     * @return 隧道设施
     */
    TunnelFacilityDO getTunnelFacility(String id);

    /**
     * 获得隧道设施分页
     *
     * @param pageReqVO 分页查询
     * @return 隧道设施分页
     */
    PageResult<TunnelFacilityDO> getTunnelFacilityPage(TunnelFacilityPageReqVO pageReqVO);

    /**
     * 启用隧道设施
     * @param id 设施id
     */
    void enable(String id);

    /**
     * 判断是否存在启用的隧道设施
     * @return Boolean
     */
    boolean existEnable();

    /**
     * 禁用隧道设施
     * @param id 设施id
     */
    void disEnable(String id);

    /**
     * 获取启用列表
     * @return 设施列表
     */
    List<TunnelFacilityDO> getEnableList();

}
